Package org.zkoss.zkmax.zul

## Class GoldenPanel

- java.lang.Object
- - org.zkoss.zk.ui.AbstractComponent
  - - org.zkoss.zk.ui.HtmlBasedComponent
    - - org.zkoss.zul.impl.XulElement
      - - org.zkoss.zkmax.zul.GoldenPanel

- All Implemented Interfaces:
    `java.io.Serializable`, `java.lang.Cloneable`, `Component`, `Scope`, `ComponentCtrl`

      public class GoldenPanel
      extends XulElement

  A GoldenPanel component. Which is the only child type for `GoldenLayout`.
  Since:
    8.6.0
  See Also:
    Serialized Form

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from class org.zkoss.zk.ui.HtmlBasedComponent

      `HtmlBasedComponent.ExtraCtrl`

    - ### Nested classes/interfaces inherited from class org.zkoss.zk.ui.AbstractComponent

      `AbstractComponent.Children, AbstractComponent.ForwardInfo, AbstractComponent.TargetInfo`

  - ### Field Summary

    - ### Fields inherited from class org.zkoss.zk.ui.HtmlBasedComponent

      `_zclass`

    - ### Fields inherited from interface org.zkoss.zk.ui.Component

      `APPLICATION_SCOPE, COMPONENT_SCOPE, DESKTOP_SCOPE, PAGE_SCOPE, REQUEST_SCOPE, SESSION_SCOPE, SPACE_SCOPE`

    - ### Fields inherited from interface org.zkoss.zk.ui.sys.ComponentCtrl

      `AFTER_CHILD_ADDED, AFTER_CHILD_REMOVED, AFTER_CLONED, AFTER_PAGE_ATTACHED, AFTER_PAGE_DETACHED, AFTER_PARENT_CHANGED, CE_BUSY_IGNORE, CE_DUPLICATE_IGNORE, CE_IMPORTANT, CE_NON_DEFERRABLE, CE_REPEAT_IGNORE`

  - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `GoldenPanel()` |
    `GoldenPanel​(java.lang.String area)` |

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `void` | `beforeParentChanged​(Component parent)` | Default: If parent is null, execute the @Destroy method if any.
    `protected void` | `droppedTo​(GoldenPanel dropTarget, java.lang.String region)` |
    `protected void` | `droppedToRoot​(java.lang.String region)` |
    `boolean` | `evalCSSFlex()` | Get whether css flex is enabled or not
    `java.lang.String` | `getArea()` |
    `java.util.Map<java.lang.String,​java.lang.Integer>` | `getLocation()` | Returns the location x0, x1, y0, y1 in the GoldenLayout areas layout matrix of this GoldenPanel.
    `PropertyAccess` | `getPropertyAccess​(java.lang.String prop)` | Returns the corresponding property access object from the given property name, if any.
    `java.lang.String` | `getTitle()` | Returns the title on the tab of the GoldenPanel.
    `boolean` | `isClosable()` | Returns whether this panel is closable.
    `boolean` | `isDraggable()` | Returns whether the GoldenPanel should be draggable.
    `boolean` | `isDroppable()` | Returns whether the stack of this GoldenPanel is droppable by other GoldenPanel.
    `void` | `onClose()` |
    `void` | `onInitMatrix()` |
    `protected void` | `renderProperties​(ContentRenderer renderer)` | Renders the content of this component, excluding the enclosing tags and children.
    `void` | `service​(AuRequest request, boolean everError)` | Processes an AU request.
    `void` | `setArea​(java.lang.String area)` | Sets the area of this GoldenPanel, use to represent the area of this panel on initial rendering.
    `void` | `setClosable​(boolean closable)` | Sets whether this panel is closable.
    `void` | `setDraggable​(boolean draggable)` | Sets whether the GoldenPanel should be draggable or not.
    `void` | `setDroppable​(boolean droppable)` | Sets whether the whole stack of this GoldenPanel is droppable by other GoldenPanel.
    `void` | `setHeight​(java.lang.String height)` | Not supported, use vflex instead.
    `void` | `setHflex​(java.lang.String flex)` | Sets horizontal flex hint of this component.
    `protected void` | `setHflexDirectly​(java.lang.String flex)` | Sets the hflex directly without sending back the result (smart update) to the client
    `void` | `setTitle​(java.lang.String title)` | Sets the title to the tab of the GoldenPanel.
    `void` | `setVflex​(java.lang.String flex)` | Sets vertical flexibility hint of this component.
    `protected void` | `setVflexDirectly​(java.lang.String flex)` | Sets the vflex directly without sending back the result (smart update) to the client
    `void` | `setWidth​(java.lang.String width)` | Not supported, use hflex instead.

    - ### Methods inherited from class org.zkoss.zul.impl.XulElement

      `clone, getContext, getCtrlKeys, getPopup, getTooltip, setContext, setContext, setContextAttributes, setCtrlKeys, setPopup, setPopup, setPopupAttributes, setTooltip, setTooltip, setTooltipAttributes`

    - ### Methods inherited from class org.zkoss.zk.ui.HtmlBasedComponent

      `addSclass, focus, getAction, getClientAction, getDraggable, getDroppable, getExtraCtrl, getHeight, getHflex, getLeft, getRenderdefer, getSclass, getStyle, getTabindex, getTabindexInteger, getTooltiptext, getTop, getVflex, getWidth, getZclass, getZindex, getZIndex, removeSclass, removeSclass, setAction, setClass, setClientAction, setDraggable, setDroppable, setFocus, setHeight0, setHeightDirectly, setHflex0, setLeft, setLeftDirectly, setRenderdefer, setSclass, setStyle, setTabindex, setTabindex, setTooltiptext, setTop, setTopDirectly, setVflex0, setWidth0, setWidthDirectly, setZclass, setZindex, setZIndex, setZIndexDirectly`

    - ### Methods inherited from class org.zkoss.zk.ui.AbstractComponent

      `addAnnotation, addCallback, addClientEvent, addEventHandler, addEventListener, addEventListener, addForward, addForward, addForward, addForward, addMoved, addRedrawCallback, addScopeListener, addShadowRoot, addShadowRootBefore, addSharedEventHandlerMap, appendChild, applyProperties, beforeChildAdded, beforeChildRemoved, destroyIndexCacheMap, detach, didActivate, didActivate, didDeserialize, didDeserialize, disableBindingAnnotation, disableClientUpdate, disableHostChanged, enableBindingAnnotation, enableHostChanged, getAnnotatedProperties, getAnnotatedPropertiesBy, getAnnotation, getAnnotations, getAnnotations, getAttribute, getAttribute, getAttribute, getAttributeOrFellow, getAttributes, getAttributes, getAuService, getAutag, getCallback, getChildren, getClientAttribute, getClientDataAttribute, getClientEvents, getDefaultMold, getDefinition, getDesktop, getEventHandler, getEventHandlerNames, getEventListenerMap, getEventListeners, getFellow, getFellow, getFellowIfAny, getFellowIfAny, getFellows, getFirstChild, getForwards, getId, getIndexCacheMap, getLastChild, getMold, getNextSibling, getPage, getParent, getPreviousSibling, getRedrawCallback, getRoot, getShadowFellowIfAny, getShadowRoots, getShadowVariable, getShadowVariable, getShadowVariable0, getSpaceOwner, getSpecialRendererOutput, getStubonly, getSubBindingAnnotationCount, getTemplate, getTemplateNames, getUuid, getWidgetAttributeNames, getWidgetClass, getWidgetListener, getWidgetListenerNames, getWidgetOverride, getWidgetOverrideNames, hasAttribute, hasAttribute, hasAttribute, hasAttributeOrFellow, hasBindingAnnotation, hasFellow, hasFellow, hasSubBindingAnnotation, initIndexCacheMap, insertBefore, invalidate, isChildable, isDisabledHostChanged, isInitialized, isInvalidated, isListenerAvailable, isVisible, onChildAdded, onChildRemoved, onPageAttached, onPageDetached, onParentChanged, onWrongValue, query, queryAll, redraw, redrawChildren, removeAttribute, removeAttribute, removeAttribute, removeCallback, removeChild, removeEventListener, removeForward, removeForward, removeRedrawCallback, removeScopeListener, removeShadowRoot, render, render, render, renderPropertiesOnly, replace, response, response, response, service, sessionDidActivate, sessionWillPassivate, setAttribute, setAttribute, setAttribute, setAuService, setAutag, setClientAttribute, setClientDataAttribute, setDefinition, setDefinition, setId, setMold, setPage, setPageBefore, setParent, setStubonly, setStubonly, setSubBindingAnnotationCount, setTemplate, setVisible, setVisibleDirectly, setWidgetClass, setWidgetListener, setWidgetOverride, smartUpdate, smartUpdate, smartUpdate, smartUpdate, smartUpdate, smartUpdate, smartUpdate, smartUpdate, smartUpdate, smartUpdateWidgetListener, smartUpdateWidgetOverride, toString, updateByClient, updateSubBindingAnnotationCount, willPassivate, willPassivate, willSerialize, willSerialize`

    - ### Methods inherited from class java.lang.Object

      `equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

- - ### Constructor Detail

    - #### GoldenPanel

          public GoldenPanel()

    - #### GoldenPanel

          public GoldenPanel​(java.lang.String area)

  - ### Method Detail

    - #### onInitMatrix

          public void onInitMatrix()

    - #### getArea

          public java.lang.String getArea()

      Returns:
        the area of this GoldenPanel.

    - #### setArea

          public void setArea​(java.lang.String area)

      Sets the area of this GoldenPanel, use to represent the area of this panel on initial rendering. Note that the area is not changeable after specified. And it doesn't remain the same due to user's action.
      Parameters:
        `area` - of this GoldenPanel

    - #### setWidth

          public void setWidth​(java.lang.String width)

      Not supported, use hflex instead.
      Overrides:
        `setWidth` in class `HtmlBasedComponent`
      See Also:
        `HtmlBasedComponent.setWidthDirectly(java.lang.String)`, `AbstractComponent.disableClientUpdate(boolean)`

    - #### setHeight

          public void setHeight​(java.lang.String height)

      Not supported, use vflex instead.
      Overrides:
        `setHeight` in class `HtmlBasedComponent`

    - #### setVflexDirectly

          protected void setVflexDirectly​(java.lang.String flex)

      Description copied from class: `HtmlBasedComponent`
      Sets the vflex directly without sending back the result (smart update) to the client
      Overrides:
        `setVflexDirectly` in class `HtmlBasedComponent`

    - #### setVflex

          public void setVflex​(java.lang.String flex)

      Description copied from class: `HtmlBasedComponent`
      Sets vertical flexibility hint of this component.

      Number flex indicates how this component's container distributes remaining empty space among its children vertically. Flexible component grow and shrink to fit their given space. Flexible components with larger flex values will be made larger than components with lower flex values, at the ratio determined by all flexible components. The actual flex value is not relevant unless there are other flexible components within the same container. Once the default sizes of components in a container are calculated, the remaining space in the container is divided among the flexible components, according to their flex ratios.

      Specify a flex value of negative value, 0, or "false" has the same effect as leaving the flex attribute out entirely. Specify a flex value of "true" has the same effect as a flex value of 1.

      Special flex hint, "min", indicates that the minimum space shall be given to this flexible component to enclose all of its children components. That is, the flexible component grow and shrink to fit its children components.

      Overrides:
        `setVflex` in class `HtmlBasedComponent`
      Parameters:
        `flex` - the vertical flex hint.
      See Also:
        `HtmlBasedComponent.setHflex(java.lang.String)`, `HtmlBasedComponent.getVflex()`

    - #### setHflexDirectly

          protected void setHflexDirectly​(java.lang.String flex)

      Description copied from class: `HtmlBasedComponent`
      Sets the hflex directly without sending back the result (smart update) to the client
      Overrides:
        `setHflexDirectly` in class `HtmlBasedComponent`

    - #### setHflex

          public void setHflex​(java.lang.String flex)

      Description copied from class: `HtmlBasedComponent`
      Sets horizontal flex hint of this component.

      Number flex indicates how this component's container distributes remaining empty space among its children horizontally. Flexible component grow and shrink to fit their given space. Flexible components with larger flex values will be made larger than components with lower flex values, at the ratio determined by all flexible components. The actual flex value is not relevant unless there are other flexible components within the same container. Once the default sizes of components in a container are calculated, the remaining space in the container is divided among the flexible components, according to their flex ratios.

      Specify a flex value of negative value, 0, or "false" has the same effect as leaving the flex attribute out entirely. Specify a flex value of "true" has the same effect as a flex value of 1.

      Special flex hint, "min", indicates that the minimum space shall be given to this flexible component to enclose all of its children components. That is, the flexible component grow and shrink to fit its children components.

      Overrides:
        `setHflex` in class `HtmlBasedComponent`
      Parameters:
        `flex` - horizontal flex hint of this component.
      See Also:
        `HtmlBasedComponent.setVflex(java.lang.String)`, `HtmlBasedComponent.getHflex()`

    - #### getTitle

          public java.lang.String getTitle()

      Returns the title on the tab of the GoldenPanel.
      Returns:
        the title

    - #### setTitle

          public void setTitle​(java.lang.String title)

      Sets the title to the tab of the GoldenPanel.
      Parameters:
        `title` -

    - #### isDraggable

          public boolean isDraggable()

      Returns whether the GoldenPanel should be draggable.

      Note that this method overwrites the normal action of zk isDraggable. Draggable true doesn't performs the normal zk draggable action, but only the GoldenPanel tabs are draggable.

      Returns:
        draggable or not

    - #### setDraggable

          public void setDraggable​(boolean draggable)

      Sets whether the GoldenPanel should be draggable or not.

      Note that this method overwrites the normal action of zk setDraggable. Setting true doesn't performs the normal zk draggable action, but only the GoldenPanel tabs are draggable.

      Parameters:
        `draggable` -

    - #### isDroppable

          public boolean isDroppable()

      Returns whether the stack of this GoldenPanel is droppable by other GoldenPanel.
      Returns:
        droppable or not

    - #### setDroppable

          public void setDroppable​(boolean droppable)

      Sets whether the whole stack of this GoldenPanel is droppable by other GoldenPanel.
      Parameters:
        `droppable` -

    - #### isClosable

          public boolean isClosable()

      Returns whether this panel is closable.
      Returns:
        closable or not

    - #### setClosable

          public void setClosable​(boolean closable)

      Sets whether this panel is closable.
      Parameters:
        `closable` -

    - #### onClose

          public void onClose()

    - #### beforeParentChanged

          public void beforeParentChanged​(Component parent)

      Description copied from class: `AbstractComponent`
      Default: If parent is null, execute the @Destroy method if any.
      Specified by:
        `beforeParentChanged` in interface `ComponentCtrl`
      Overrides:
        `beforeParentChanged` in class `AbstractComponent`
      Parameters:
        `parent` - the new parent. If null, it means detachment.
      See Also:
        `ComponentCtrl.beforeParentChanged(org.zkoss.zk.ui.Component)`

    - #### droppedToRoot

          protected void droppedToRoot​(java.lang.String region)

    - #### droppedTo

          protected void droppedTo​(GoldenPanel dropTarget,
                                   java.lang.String region)

    - #### getLocation

          public java.util.Map<java.lang.String,​java.lang.Integer> getLocation()

      Returns the location x0, x1, y0, y1 in the GoldenLayout areas layout matrix of this GoldenPanel.
      Returns:
        the location x0, x1, y0, y1

    - #### renderProperties

          protected void renderProperties​(ContentRenderer renderer)
                                   throws java.io.IOException

      Description copied from class: `HtmlBasedComponent`
      Renders the content of this component, excluding the enclosing tags and children.

      See also ZK Client-side Reference: Property Rendering

      Overrides:
        `renderProperties` in class `XulElement`
      Throws:
        `java.io.IOException`

    - #### service

          public void service​(AuRequest request,
                              boolean everError)

      Description copied from class: `HtmlBasedComponent`
      Processes an AU request.

      Default: it handles onClick, onDoubleClick, onRightClick onMove, onSize, onZIndex.

      Specified by:
        `service` in interface `ComponentCtrl`
      Overrides:
        `service` in class `HtmlBasedComponent`
        `everError` - whether any error ever occurred before processing this request.
      See Also:
        `AbstractComponent.setAuService(org.zkoss.zk.au.AuService)`

    - #### getPropertyAccess

          public PropertyAccess getPropertyAccess​(java.lang.String prop)

      Description copied from interface: `ComponentCtrl`
      Returns the corresponding property access object from the given property name, if any.
      Specified by:
        `getPropertyAccess` in interface `ComponentCtrl`
      Overrides:
        `getPropertyAccess` in class `XulElement`
      Parameters:
        `prop` - the name of the property
      Returns:
        null it means not to support for the property name.

    - #### evalCSSFlex

          public boolean evalCSSFlex()

      Description copied from class: `HtmlBasedComponent`
      Get whether css flex is enabled or not
      Overrides:
        `evalCSSFlex` in class `HtmlBasedComponent`
      Returns:
        css flex is enabled